function [starts, ends] = endsalg2(flow, purezerosinsp, purezerosexp, treshold)

%treshold1 = 0.25; % in l/s
%treshold2 = 0.01;

crossings = [];


% cleaning
starts = purezerosexp; % +/- crossings
ends = purezerosinsp;  % -/+ crossings





% cleaning inhalatios
% we first start cleaning inhalations to make sure the end of breath is last 
% zero crossing before flow goes to +treshold
j = 1;
slen = min( length(starts), length(ends) ); % abychom si byli jisti, že ke konci máme i začátek
while (j < slen)
  s = ends(j);
  e = starts(j+1);
  fl = flow(s:e);
  m = max(fl);
    
  if(m < treshold)
    % pruning to small flow oscilations  
    starts = starts([1:j, (j+2):slen]);
    ends = ends([1:(j-1), (j+1):slen]);
    slen = slen - 1;
  else
    j = j + 1;   
  end
  
end



% cleaning exhalations
j = 1;
slen = min( length(starts), length(ends) ); % abychom si byli jisti, že ke konci máme i začátek
while (j <= slen)
  s = starts(j);
  e = ends(j);
  fl = -flow(s:e);
  m = max(fl);
    
  if(m < treshold)
    % pruning to small flow oscilations  
    starts = starts([1:(j-1), (j+1):slen]);
    ends = ends([1:(j-1), (j+1):slen]);
    slen = slen - 1;
  else
    j = j + 1;   
  end
  
end




end