function crossings = findzerocrossings(flow, time, co2)  

  % marks intervals covering each zero crossings

  crossings = [];
  indices = [];
  
  
  
  
  
  
  for i=1:length(flow)-1
  
   if((flow(i)<=0) && (flow(i+1) >= 0) )
       % time starts with 0 and a window is 0.005 s
       [left, right] = inflate(i, flow);
       
       if (left && right)
          crossings = [crossings;  infsup(left, right)];
       end  
   end
  end
  printf("Number of breaths according to zerocrosings: %d \n", length(crossings));

  
  %*************************************************************************
  % merge intersecting close intervals
  %*************************************************************************
  
  mcrossings = [];
  i = 1;
  while (i <= length(crossings) )
    mcross = crossings(i);
    j = i+1;
    
    while (j <= length(crossings) && ( sup(mcross) >= inf(crossings(j) )) ) 
      mcross = union(mcross, crossings(j));
      j = j + 1;
    end  
    mcrossings = [mcrossings; mcross];
    
    % skip the merged intervals
    i = j;
    
    
  end
    crossings = mcrossings;
        
   printf("Number of breaths after merging overlapping ones: %d \n", length(crossings));

    
    
  %*************************************************************************
  % delete crossing that correspond to nitrogen concentration
  % lower that 1 LCI5
  %************************************************************************* 
  

  i = 1;
  while i <= length(crossings)
    len = length(crossings);
    indices = crossings(i);
    vals = co2(inf(indices):sup(indices));
    
    if (max(vals) < 2)
      newind = [1:(i-1), (i+1):len];
      crossings = crossings(newind);
    else
      i=i+1;
    end 
  end
    

end