

 function loadwashoutbut(src, data)
   
    data = guidata(src);    
    
    clc;
    
    %---------------------------------------------------------------------------
    % !!!! load and save have problems when there are white spaces in path or name of the file
    %---------------------------------------------------------------------------
    
   
    %filename = uigetfile();
    [filename,path] = uigetfile('*.txt','Select the washout file');

    disp("---------------------------------------------------------------------");
    disp(filename);
    disp("---------------------------------------------------------------------");
    
    % adds filename to a title of figure 
    %figure('name', strcat('Lungo 1.0: ', filename));
    
    % !!! problem if the filename is empty - freezes
    if (isempty(filename))
      return
    end
    
    
    % zajistit aby se vyčistila obrazovka pro výpis
    
    
    data.filename = filename;
    filename = strcat(path, filename);
       
    % reads data from file filename with any empty character as delimiter
    % but first it skips 2 rows and 0 columns    
    rawdata = dlmread(filename, '', 2, 0);
     
    % dodat test na neprázdnost řetězce  !!! 
    % dodat test na správnost čtení souboru !!!
    
    
    data.time = rawdata(:, 1)./1000;
    data.flow = rawdata(:, 2);
    data.o2 = rawdata(:, 3);
    data.co2 = rawdata(:, 4);
    data.nitrogen = rawdata(:, 5);
    %data.co2(41600:42000)
    
    
    % find zero crossings - returns interval indices
    %data.zerocrossings = findzerocrossings(data.flow, data.time, data.co2);
    
%    purezeros = [];
%    for i=1:length(data.flow)-1
%      if((data.flow(i)<=0) && (data.flow(i+1) >= 0))
%       purezeros = [purezeros;  i];  
%      end
%    end
%    data.purezeros = purezeros;
%    printf("Number of pure zeros: %d \n", length(data.purezeros));
    
    
    
    tic;
    index = 1;
    flen = length(data.flow);
    purezerosinsp = []; % starts of inspiration, end of expiration
    purezerosexp = []; % end of inspiration, start of expiration
    
    search = 0;
    while index < flen 
      if((data.flow(index)>=0) && (data.flow(index+1) < 0) )
        purezerosexp = [purezerosexp; index];
        search = 1;
        i = index + 1;
        while (i < flen) && search
          if ( (data.flow(i) <= 0) && (data.flow(i+1) > 0) ) 
            search = 0;
          else
            i = i + 1;
          end    
        end
        purezerosinsp = [purezerosinsp; i];
        index = i;
      else
        index = index + 1;
      end
    end
    data.purezerosinsp = purezerosinsp;
    data.purezerosexp = purezerosexp;
    purezerostime = toc;
    
    printf("Number of pure zeros insp: %d \n", length(data.purezerosinsp));
    printf("Number of pure zeros exp: %d \n", length(data.purezerosexp)); 
    printf("Found in time: %d \n\n", purezerostime);   
    
    
    
    
    
    
    % -------------------------------------------------------------------------
    % finding breath ends according to various algorithms ---------------------
    % -------------------------------------------------------------------------
      tic;
      % first choice of parameter treshold = 0.25
      [data.starts21, data.ends21] = endsalg2(data.flow, data.purezerosinsp, data.purezerosexp, 0.25);
      time2 = toc;
      %tic;
      
      % second choice of parameter treshold = 0.01
      [data.starts22, data.ends22] = endsalg2(data.flow, data.purezerosinsp, data.purezerosexp, 0.01);
      
      
%      
      data.ends31 = endsalg3(data.starts21, data.ends21, data.time);
%      length(data.ends31)
%      %time3 = toc;
%      %tic;
%      
      data.ends32 = endsalg3(data.starts22, data.ends22, data.time);
%      length(data.ends32)
      %data.ends1985 = endsalg1985(data.zerocrossings, data.co2);
      tic;
      data.endsour = endsalgour(data.purezerosinsp, data.purezerosexp, data.flow, data.co2);
      timeour = toc;
      
      printf("\nRuntime of ALG-2: %d sec \n", time2);      
      %printf("Runtime of ALG-3: %d sec \n", time3);  
      printf("Runtime of ALG-OUR: %d sec \n\n", timeour); 
      
      
      
      
      
      
%      % output of nitrogen concentrations
%      n2max = [];
%      l = length(data.endsour);
%      for i=1:l
%        s = inf(data.endsour(i));
%        e = sup(data.endsour(i));
%        
%        while ( s > 1 && data.nitrogen(s) > data.nitrogen(s-1)  )
%          s = s - 1;
%        end
%        
%        while ( e < (length(data.nitrogen)-1) && data.nitrogen(e) < data.nitrogen(e+1)  )
%          e = e + 1;
%        end
%        
%        arr = data.nitrogen(s:e);
%        n2max = [n2max; max(arr)];
%        
%      end
%      save "n2curve" n2max; 
      
      
      
      printf("\nNumber of breaths detected by ALG-3- treshold 0.25 l/s: %d \n", length(data.ends31));      
      printf("Number of breaths detected by ALG-3 - treshold 0.01 l/s %d \n", length(data.ends32));  
      %printf("Number of breaths detected by ALG-1985: %d \n", length(data.ends1985));  
      printf("Number of breaths detected by ALG-OUR: %d \n", length(data.endsour));  
      
      
      
      
    % -------------------------------------------------------------------------
    % -------------------------------------------------------------------------

    % extracts maximum from nitrogen and minimum from flow
    datatoplot = 8;
    plotmax = max(datatoplot);
    datatoplot = abs(data.flow);
    plotmin = max(datatoplot);
    
    data.plotmax = 8;
    data.plotmin = -plotmin;
    
    
  
    % saving precomputed data
    guidata(src, data); 
    
    
    % automatically plots nitrogen 
    visualize(data);
    
  end
