function visualize(data)

  
  if length(data.flow) <= 0
    return
  end
  

  cla;
  
  
  %=======================================================================
  % CONTINUOUS NITROGEN VISUALIZATION
  %=======================================================================
   
  
   
   colorco2 =  [0.38, 0.42, 0.63]; 
   plot(data.time, data.co2, 'color', colorco2, 'LineWidth', 1);
   hold on;  
  
   set(gca, 'box', 'off');
   set(gca, "tickdir", "out");
   xlabel("(sec)", "fontsize", 14);
   ylabel("(% or litres/sec)", "fontsize", 14);
   maxl = max(data.time);
   set(gca, "xtick", [0:10:maxl]);
   set(gca, "ytick", [0:1:8]); 
    
    % plot estimations
%    xinf = inf(data.zerocrossings);
%    xsup = sup(data.zerocrossings);
%    timeinf = data.time(xinf);
%    timesup = data.time(xsup);
%    
    start = -3;
    step = 0.5;
    
    
    % plot nitrogen
    bckg1 = [0.98, 0.98, 0.98 ];
    rectangle ('Position', [0,0, maxl, 8], 'FaceColor', bckg1, 'EdgeColor', bckg1);
    
    
    %autotrim = data.time(data.trimindex);
    %autotrim = data.time(sup(data.endsour(1)));
    
    %plot([autotrim, autotrim], [-5, 100],"--", 'color', "red", 'LineWidth', 2);

  
    axislim = [min(data.time)  max(data.time)];
    
    %plotzerocrossings(data.time, data.zerocrossings, data.plotmin, data.plotmax);
    plotpurezeros(data.time, data.purezerosinsp, -4.5, data.plotmax); 
    
    
    
    
    if (data.plotflow)
      plot(data.time, data.flow - 1.5, 'color', 'red', 'LineWidth', 1);
    end
    
    if (data.ploto2)
      plot(data.time, data.o2, 'color', 'green', 'LineWidth', 1);
    end
    
    %if (data.plotnitrogen)
    %  plot(data.time, data.nitrogen, 'color', 'magenta', 'LineWidth', 1);
    %end
    
    
    plot([0, maxl], [0, 0],'color', "black", 'LineWidth', 1); 
   
    
    % axes for table for end results
    bckg = [1, 0.95, 0.6];
   
    
  
    
    
    
     plot([0, maxl], [-1.5, -1.5],'color', "black", 'LineWidth', 1); 
    
    grey = [0.5,0.5,0.5];
    rectangle ('Position', [0,start-3*step, maxl, 3*step], 'FaceColor', bckg, 'EdgeColor', bckg);
    
    plot([0, maxl], [start, start ],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [start - 1*step, start - 1*step],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [start - 2*step, start - 2*step],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [start - 3*step, start - 3*step],"--", 'color', grey, 'LineWidth', 1);
   % plot([0, maxl], [start - 4*step, start - 4*step],"--", 'color', grey, 'LineWidth', 1);
   
    % lines for tresholds
    c = -1.5;
    plot([0, maxl], [c + 0.25, c + 0.25 ],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [c - 0.25, c - 0.25],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [c + 0.01, c + 0.01],"--", 'color', grey, 'LineWidth', 1);
    plot([0, maxl], [c - 0.01, c - 0.01],"--", 'color', grey, 'LineWidth', 1);
    
    
    
   
  color2 = "black"; 
  color3 = [0,0.3, 0];
  colorour = [0.22,0.1, 0.48];
    
   % if(data.plotends2)
       plotends(infsup(data.ends21), data.time, start - step, step,  color2);
   % end
    
   % if(data.plotends3)
       plotends(infsup(data.ends22), data.time, start - 2*step, step, color3);
   % end
    
   % if(data.plotends1985)
   %    plotends(data.ends1985, data.time, start - 3*step, step, "magenta"); 
   % end
    
   % if(data.plotendsour)
       plotends(data.endsour, data.time, start - 3*step, step, colorour);
   % end
    
    %len = length(data.zerocrossings); 
    %ind = inf(data.zerocrossings) ;
    %plot(data.time(ind), zeros(len, 1), 'o');
    
     
    h = zeros(3, 1);
h(1) = plot(NaN,NaN, "o" , "Color", color2);
h(2) = plot(NaN,NaN,"o", "Color", color3);
h(3) = plot(NaN,NaN,"o", "Color", "magenta");
%h(4) = plot(NaN,NaN,"o", "Color", colorour);
set(h, "color", bckg);
%set(h, 'fontsize', 12);

legend(h, "ALG-3 - treshold:0.25 l/s",'ALG-3 - treshold:0.01 l/s', 'ALG-OUR', "Location", "southeast");  

  
%    leg = legend("ALG-1", "ALG-2", "ALG-OUR", "Location", "southwestoutside");
%    legtxt=findobj(leg,'type','text');
%    set(legtxt(1), 'Color', 'magenta');
%    set(legtxt(2), 'Color', 'blue');
%    set(legtxt(3), 'Color', 'red');
%    

tit = strcat("File: ", data.filename);
title(tit, "fontsize", 14);     
  
  end

